<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
require_once $base_path_to_learning . 'functions/get_branch_functions.php';

//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

$postdata = json_decode(file_get_contents("php://input"), true);
//print_r($postdata);
checkIfNoPhpContentsReceive();

if (
    !isset($postdata['institution_id']) or !checkIfIssetAndNotEmpty($postdata['institution_id']) or
    !isset($postdata['branch_id']) or !checkIfIssetAndNotEmpty($postdata['branch_id']) or
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type']) or
    !isset($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}

validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
//then workspace_id is iin decodede data of jwt use from there
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id,['superadmin','admin','principal','teacher'], null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}



function getOtpSettings($conn_rjllearning_specific, $institution_id, $branch_id, $search_string, $limit, $offset)
{
    // Count total rows for pagination
    $sql_count = "SELECT COUNT(*) AS total_rows FROM institution_global_settings WHERE institution_id = ? AND branch_id = ?";
    $stmt = $conn_rjllearning_specific->prepare($sql_count);
    $stmt->execute([$institution_id, $branch_id]);
    $result_total = $stmt->fetch();
    $totalrows = $result_total['total_rows'];

    // Prepare SQL query with branch_id and search_string
    $sql = "SELECT * FROM institution_global_settings WHERE institution_id = ? AND branch_id = ?";
    $params = [$institution_id, $branch_id];

    if ($search_string != null) {
        $sql .= " AND otp_setting LIKE ?";
        $params[] = '%' . $search_string . '%';
    }
    
    // if ($search_string != null) {
    //     $sql .= " AND homework_setting LIKE ?";
    //     $params[] = '%' . $search_string . '%';
    // }

    $sql .= " LIMIT " . $offset . " ," . $limit . " ";
    $stmt = $conn_rjllearning_specific->prepare($sql);
    $stmt->execute($params);
    $result_class = $stmt->fetchAll();

    $array_return = [];
    if (count($result_class) >= 1) {
        foreach ($result_class as $rows) {
            $otp_settings = json_decode($rows['otp_setting'], true);
            // $homework_settings = json_decode($rows['homework_setting'], true);
            $array_return[] = array(
                'setting_id' => $rows['id'],
                'institution_id' => $rows['institution_id'],
                'branch_id' => $rows['branch_id'],
                'otp_settings' => $otp_settings,
                // 'homework_setting' => $homework_settings
            );
        }
    }

    if (count($result_class) < 50) {
        return array('total_rows' => $totalrows, 'otp_settings' => $array_return, 'maxreach' => 1);
    } else {
        return array('total_rows' => $totalrows, 'otp_settings' => $array_return, 'maxreach' => 0);
    }
}


if ($postdata['function_type'] == "fetch_otp_settings") {
    if (isset($postdata['search_string']) and !empty($postdata['search_string'])) {
        $search_string = trim($postdata['search_string']);
    } else {
        $search_string = null;
    }

    $limit = $postdata['limit'];
    $institution_id = trim($postdata['institution_id']);
    $branch_id = trim($postdata['branch_id']);
    $page = (isset($postdata['page']) and isNumeric($postdata['page'])) ? (int)$postdata['page'] : 1;

    // Validate academic session or access permissions
    $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
    if ($check_academic_confirmation != true) {
        errorreturn("Access denied. Academic session not active.");
    }
    $isBranchClassSubjectValid = checkBranchClassSubject($conn_rjllearning_specific, $branch_id, null, null, $institution_id);
    if (!$isBranchClassSubjectValid) {
        errorreturn("Invalid branch_id.");
    }

    if ($limit != 'all') {
        $offset = ($page - 1) * $limit;
        $success['data'] = getOtpSettings($conn_rjllearning_specific, $institution_id, $branch_id, $search_string, $limit, $offset);
        successreturn($success);
    } else {
        $success['data'] = getOtpSettings($conn_rjllearning_specific, $institution_id, $branch_id, $search_string, $limit, null);
        successreturn($success);
    }
} else {
    errorreturn("Invalid Function Type");
}
